/* 
 * EDOMI beta (Version 1.52) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 13 (Schieberegler)
//----------------------------

function control13_constructControl(obj,item) {
	var n="";
	if (obj.dataset.var1 & 64) {	
		//mit Pfad
		n+="<div id='e-"+item.id+"-sliderline' style='position:absolute; left:0; top:0; opacity:0.25; box-sizing:border-box;'></div>";
		n+="<div id='e-"+item.id+"-sliderknob' style='position:absolute; left:0; top:0; border:1px solid; background:currentColor; box-sizing:border-box;'></div>";
	} else {
		//ohne Pfad
		n+="<div id='e-"+item.id+"-sliderknob' style='position:absolute; left:0; top:0; border:1px solid; background:currentColor; box-sizing:border-box;'></div>";
	}
	n+="<table cellpadding='0' cellspacing='0' border='0' style='position:absolute; left:0; top:0; width:100%; height:100%; pointer-events:none;'>";
		n+="<tr><td><span id='e-"+item.id+"-text'></span></td></tr>";
	n+="</table>";
	n+="<div id='e-"+item.id+"-edit' style='display:none; position:absolute; left:0; top:0; right:0; bottom:0; color:"+visu_indiColorText+"; pointer-events:none;'></div>";
	obj.innerHTML=n;

	obj.addEventListener(downEvent,function(){if (!checkClick()){return;} control13_Start(item.id);},false);
}

function control13_refreshControl(obj,design,init) {
	obj.dataset.blocked=0;
	obj.dataset.caption=design.caption;
	document.getElementById("e-"+design.elementid+"-text").innerHTML=pS(design.text,design.kovalue);
	control13_Init(design.elementid,design.kovalue);
}

function control13_Init(elementId,koValue) {
	var d=document.getElementById("e-"+elementId);
	if (elementId==elementDragId) {return;}
	var objButton=document.getElementById("e-"+elementId+"-sliderknob");
	var objLine=document.getElementById("e-"+elementId+"-sliderline");
	if (objButton) {
		var slider=control13_initSlider(d,objButton,objLine,false);
		if (parseFloat(koValue)<slider.vmin) {koValue=slider.vmin;}
		if (parseFloat(koValue)>slider.vmax) {koValue=slider.vmax;}

		if (slider.orientation==0) {	//horizontal
			if (slider.flip==0) {
				var position=slider.offset+((koValue-slider.vmin)*((slider.maxLength-slider.knobWidth)/Math.abs(slider.vmax-slider.vmin)));
			} else {
				var position=slider.offset+(slider.maxLength-slider.knobWidth)-((koValue-slider.vmin)*((slider.maxLength-slider.knobWidth)/Math.abs(slider.vmax-slider.vmin)));
			}
			objButton.style.left=position+"px";
			objButton.style.top=(slider.height/2-(slider.knobHeight)/2)+"px";
		} else {						//vertikal
			if (slider.flip==0) {
				var position=slider.offset+(slider.maxLength-slider.knobHeight)-((koValue-slider.vmin)*((slider.maxLength-slider.knobHeight)/Math.abs(slider.vmax-slider.vmin)));
			} else {
				var position=slider.offset+((koValue-slider.vmin)*((slider.maxLength-slider.knobHeight)/Math.abs(slider.vmax-slider.vmin)));
			}
			objButton.style.left=(slider.width/2-(slider.knobWidth)/2)+"px"; 
			objButton.style.top=position+"px";  
		}
	}
}

function control13_Start(elementId) {
	if (!event) var event=window.event;
	var d=document.getElementById("e-"+elementId);
	if (d.dataset.blocked==1) {return;}

	elementDragId=elementId;

	document.getElementById("e-"+elementId+"-text").style.display="none";
	document.getElementById("e-"+elementId+"-edit").style.display="inline";

	d.dataset.oldx=parseInt(getPageX(event));
	d.dataset.oldy=parseInt(getPageY(event));
	d.dataset.editvalue=d.dataset.value;
	if (d.dataset.editvalue=="") {d.dataset.editvalue=0;}
	control13_Move();

	window.addEventListener(moveEvent,control13_Move,false);
	window.addEventListener(upEvent,control13_Send,false);

	if (visu_allowScrolling) {
		//Scrolling temporär verhindern
		window.addEventListener(moveEvent,disableScrolling,false);
	}

}

function control13_Move() {
	if (!event) var event=window.event;
	if (elementDragId>0) {
		var d=document.getElementById("e-"+elementDragId);
		if (d && d.dataset.controltyp==13) {

			var slider=control13_initSlider(d,false,false,false);
			var objButton=document.getElementById("e-"+elementDragId+"-sliderknob");

			if (slider.orientation==0) {
				//horizontal
				var x=getPageX(event);
				var relPosition=x-d.dataset.oldx;
				var value=parseFloat(d.dataset.editvalue);
				if (slider.flip==0) {
					var tmp=parseFloat(value+(relPosition*(Math.abs(slider.vmax-slider.vmin)/slider.maxLength)));
				} else {
					var tmp=parseFloat(value-(relPosition*(Math.abs(slider.vmax-slider.vmin)/slider.maxLength)));
				}
				if (tmp<slider.vmin && !isNaN(slider.vmin)) {tmp=slider.vmin;}
				if (tmp>slider.vmax && !isNaN(slider.vmax)) {tmp=slider.vmax;}
				if (slider.flip==0) {
					var position=slider.offset+((tmp-slider.vmin)*((slider.maxLength-slider.knobWidth)/Math.abs(slider.vmax-slider.vmin)));	
				} else {
					var position=slider.offset+(slider.maxLength-slider.knobWidth)-((tmp-slider.vmin)*((slider.maxLength-slider.knobWidth)/Math.abs(slider.vmax-slider.vmin)));	
				}
				objButton.style.left=position+"px";
				d.dataset.oldx=x;
			} else {
				//vertikal
				var y=getPageY(event);
				var relPosition=-1*(y-d.dataset.oldy);
				var value=parseFloat(d.dataset.editvalue);
				if (slider.flip==0) {
					var tmp=parseFloat(value+(relPosition*(Math.abs(slider.vmax-slider.vmin)/slider.maxLength)));
				} else {
					var tmp=parseFloat(value-(relPosition*(Math.abs(slider.vmax-slider.vmin)/slider.maxLength)));
				}
				if (tmp<slider.vmin && !isNaN(slider.vmin)) {tmp=slider.vmin;}
				if (tmp>slider.vmax && !isNaN(slider.vmax)) {tmp=slider.vmax;}		
				if (slider.flip==0) {
					var position=slider.offset+(slider.maxLength-slider.knobHeight)-((tmp-slider.vmin)*((slider.maxLength-slider.knobHeight)/Math.abs(slider.vmax-slider.vmin)));
				} else {
					var position=slider.offset+((tmp-slider.vmin)*((slider.maxLength-slider.knobHeight)/Math.abs(slider.vmax-slider.vmin)));
				}				
				objButton.style.top=position+"px";
				d.dataset.oldy=y;
			}

			d.dataset.editvalue=tmp;	//Float! (ohne vstep+vlist)
			if (isNaN(tmp)) {
				document.getElementById("e-"+elementDragId+"-edit").innerHTML="<button class='elementContent'><span style='background:"+visu_indiColor+"; color:"+visu_indiColorText+"; padding:1px; border-radius:3px;'>?</span></button>";
			} else {
				var n=parseInt(tmp/slider.vstep)*slider.vstep;
				document.getElementById("e-"+elementDragId+"-edit").innerHTML="<button class='elementContent'><span style='background:"+visu_indiColor+"; color:"+visu_indiColorText+"; padding:1px; border-radius:3px;'>"+pS(d.dataset.caption,n.toFixed(slider.vlist))+"</span></button>";
			}
		}	
	}
}

function control13_Send() {
	var d=document.getElementById("e-"+elementDragId);
	if (d && d.dataset.controltyp==13) {

		//editvalue ist noch ein reines Float (ohne vstep+vlist)...
		var slider=control13_initSlider(d,false,false,true);
		var n=parseInt(d.dataset.editvalue/slider.vstep)*slider.vstep;
		var newValue=n.toFixed(slider.vlist);

		var setKoMode=d.dataset.var4;
		var setKoChanged=false;
		if (parseFloat(d.dataset.value)!==parseFloat(newValue)) {setKoChanged=true;}
		if ((setKoMode==0) || (setKoMode==1 && setKoChanged) || (setKoMode==2) || (setKoMode==3 && setKoChanged)) {
			if ((setKoMode==2) || (setKoMode==3 && setKoChanged)) {
				d.dataset.blocked=0;
			} else {
				d.dataset.blocked=1;
				document.getElementById("e-"+elementDragId+"-text").innerHTML="<div class='sendValueAnim'>"+document.getElementById("e-"+elementDragId+"-edit").innerHTML+"</div>";
			}
			setKoValue(d.dataset.gaid2,newValue);
		}

		document.getElementById("e-"+elementDragId+"-text").style.display="inline";
		document.getElementById("e-"+elementDragId+"-edit").style.display="none";
	
		elementDragId=0;
		window.removeEventListener(moveEvent,control13_Move,false);
		window.removeEventListener(upEvent,control13_Send,false);

		if (visu_allowScrolling) {
			//Scrolling wieder freigeben
			window.removeEventListener(moveEvent,disableScrolling,false);
		}

	}
}

function control13_initSlider(obj,objButton,objLine,filterOnly) {
/*
var1:
	Shape=Bits 0..5
		0=Unsichtbar
		1=Kreis
		2=Quadrat
		3=Rechteck
		4=Strich
	Linie=Bit 6
	Schatten=Bit 7
*/
	var vmin=parseFloat(obj.dataset.var5);
	var vmax=parseFloat(obj.dataset.var6);
	var vstep=parseFloat(obj.dataset.var7); if (isNaN(vstep)) {vstep=1;}
	var vlist=parseInt(obj.dataset.var8); if (isNaN(vlist) || vlist<0) {vlist=0;}

	if (filterOnly) {
		return {vmin:vmin,vmax:vmax,vstep:vstep,vlist:vlist};
		
	} else {
		var w=parseInt(obj.style.width.replace("px",""));
		var h=parseInt(obj.style.height.replace("px",""));
		var flip=obj.dataset.var3;	
		
		if (w>=h) {	//horizontal
		
			var orientation=0;
	
			if ((obj.dataset.var1&63)==1) {			//Kreis
				var knobWidth=h*obj.dataset.var2/100;
				var knobHeight=h*obj.dataset.var2/100;
				if (objButton) {objButton.style.borderRadius="100%";} 
			} else if ((obj.dataset.var1&63)==2) {	//Quadrat
				var knobWidth=h*obj.dataset.var2/100;
				var knobHeight=h*obj.dataset.var2/100;
			} else if ((obj.dataset.var1&63)==3) {	//Rechteck
				var knobWidth=h*obj.dataset.var2/300;
				var knobHeight=h*obj.dataset.var2/100;
			} else if ((obj.dataset.var1&63)==4) {	//Strich
				var knobWidth=1;
				var knobHeight=h*obj.dataset.var2/100;
				if (objButton) {objButton.style.border="none";} 
			} else {								//unsichtbar
				var knobWidth=1;
				var knobHeight=1;
				if (objButton) {objButton.style.visibility="hidden";} 
			}
			
			var offset=(h-knobHeight)/2;
	
			var maxLength=w-(offset*2);
	
			if (objButton) {
				objButton.style.width=knobWidth+"px";
				objButton.style.height=knobHeight+"px";
	
				if (obj.dataset.var1 & 128) {	//Schatten
					objButton.style.boxShadow="1px 1px 3px rgba(0,0,0,0.75)";
				}
			}
			if (objLine) {
				if (obj.dataset.var1 & 64) {	//Linie
					objLine.style.left=offset+"px";
					objLine.style.top=(h/2)+"px";
					objLine.style.width=(w-(offset*2))+"px";
					objLine.style.height="1px";
					objLine.style.borderBottom="1px solid";
				}
			}
	
		} else {	//vertikal
	
			var orientation=1;
			
			if ((obj.dataset.var1&63)==1) {			//Kreis
				var knobWidth=w*obj.dataset.var2/100;
				var knobHeight=w*obj.dataset.var2/100;
				if (objButton) {objButton.style.borderRadius="100%";} 
			} else if ((obj.dataset.var1&63)==2) {	//Quadrat
				var knobWidth=w*obj.dataset.var2/100;
				var knobHeight=w*obj.dataset.var2/100;
			} else if ((obj.dataset.var1&63)==3) {	//Rechteck
				var knobWidth=w*obj.dataset.var2/100;
				var knobHeight=w*obj.dataset.var2/300;
			} else if ((obj.dataset.var1&63)==4) {	//Strich
				var knobWidth=w*obj.dataset.var2/100;
				var knobHeight=1;
				if (objButton) {objButton.style.border="none";} 
			} else {								//unsichtbar
				var knobWidth=1;
				var knobHeight=1;
				if (objButton) {objButton.style.visibility="hidden";} 
			}
	
			var offset=(w-knobWidth)/2;
	
			var maxLength=h-(offset*2);
	
			if (objButton) {
				objButton.style.width=knobWidth+"px";
				objButton.style.height=knobHeight+"px";
	
				if (obj.dataset.var1 & 128) {	//Schatten
					objButton.style.boxShadow="1px 1px 3px #000000";
				}
			}
			if (objLine) {
				if (obj.dataset.var1 & 64) {	//Linie
					objLine.style.left=(w/2)+"px";
					objLine.style.top=offset+"px";
					objLine.style.width="1px";
					objLine.style.height=(h-(offset*2))+"px";
					objLine.style.borderRight="1px solid";
				}
			}
	
		}
		
		return {vmin:vmin,vmax:vmax,vstep:vstep,vlist:vlist,width:w,height:h,flip:flip,orientation:orientation,knobWidth:knobWidth,knobHeight:knobHeight,offset:offset,maxLength:maxLength};	
	}
}
