/* 
 * EDOMI beta (Version 1.52) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 15 (Farbauswahl (Bild))
//----------------------------

function control15_constructControl(obj,item) {
	var n="<canvas id='e-"+item.id+"-canvas' style='width:100%; height:100%; cursor:crosshair;'></canvas>";
	n+="<table id='e-"+item.id+"-send' cellpadding='0' cellspacing='0' border='0' style='position:absolute; left:0; top:0; width:100%; height:100%; pointer-events:none;'>";
		n+="<tr><td><span id='e-"+item.id+"-text'></span></td></tr>";
	n+="</table>";
	n+="<div id='e-"+item.id+"-edit' style='display:none; position:absolute; z-index:99999; left:0; top:0; width:90px; height:90px; border-radius:100%; border-style:solid; border-width:5px; pointer-events:none;'></div>";
	obj.innerHTML=n;

	document.getElementById("e-"+item.id+"-canvas").addEventListener(downEvent,function(){if (!checkClick()){return;} control15_Start(item.id);},false);	
}

function control15_refreshControl(obj,design,init) {
	document.getElementById("e-"+design.elementid+"-text").innerHTML=pS(design.text,design.kovalue);
	control15_Init(design.elementid,design.img);
}

function control15_Init(elementId,img) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		var canvas=document.getElementById("e-"+elementId+"-canvas");
		var tmp=window.getComputedStyle(canvas);
		var cWidth=tmp.width.replace("px","");
		var cHeight=tmp.height.replace("px","");

		var c=canvasScale(canvas,cWidth,cHeight);
		if (c!==false) {
			c.clearRect(0,0,cWidth,cHeight);
			if (img!="") {
				var tmp=new Image();
				tmp.src="../data/liveproject/visu/img/"+img;
				tmp.onload=function() {c.drawImage(tmp,0,0,cWidth,cHeight);}
			}
		}
	}
}

function control15_Start(elementId) {
	if (!event) var event=window.event;
	var d=document.getElementById("e-"+elementId);

	elementDragId=elementId;

	document.getElementById("e-"+elementId+"-text").style.display="none";
	document.getElementById("e-"+elementId+"-edit").style.display="inline";

	d.dataset.editvalue="";
	
	control15_Move();

	window.addEventListener(moveEvent,control15_Move,false);
	window.addEventListener(upEvent,control15_Send,false);

	if (visu_allowScrolling) {
		//Scrolling temporär verhindern
		window.addEventListener(moveEvent,disableScrolling,false);
	}
}

function control15_Move() {
	if (!event) var event=window.event;
	if (elementDragId>0) {
		var d=document.getElementById("e-"+elementDragId);
		if (d && d.dataset.controltyp==15) {

			var canvas=document.getElementById("e-"+elementDragId+"-canvas");
			var tmp=canvas.getBoundingClientRect();
			var x=(getClientX(event)-tmp.left)-tmp.width/2;	//Origin: Mittelpunkt der Boundingbox
			var y=(getClientY(event)-tmp.top)-tmp.height/2;
		
			var xy=canvasGetRelativeXY(canvas,cssGetRotationAngle(d),x,y) 
			if (canvas && xy!==false) {
				if (canvas.getContext) {

					var c=canvas.getContext("2d");
					var color=c.getImageData(xy.x*displayPixelRatio,xy.y*displayPixelRatio,1,1).data;
					
					var tmp=document.getElementById("e-"+elementDragId+"-edit");
					if (color[3]<255) {
					
						d.dataset.editvalue="";								
						tmp.style.borderColor="#"+d.dataset.editvalue;		
						tmp.style.display="none";
						
					} else {
					
						tmp.style.display="inline";
						tmp.style.left=parseInt(xy.x-(tmp.offsetWidth/2))+'px';
						tmp.style.top=parseInt(xy.y-(tmp.offsetHeight/2))+'px';

						if (d.dataset.var1==0) {
							var bw=RGBtoGREYSCALE(color[0],color[1],color[2]);
							if (bw!==false) {
								d.dataset.editvalue=bw;
								tmp.style.borderColor="rgb("+bw+","+bw+","+bw+")";
							}
						} else if (d.dataset.var1==1) {
							var rgb=RGBtoRGBHEX(color[0],color[1],color[2]);
							if (rgb!==false) {
								d.dataset.editvalue=rgb;
								tmp.style.borderColor="#"+rgb;					
							}
						} else if (d.dataset.var1==2) {
							var hsv=RGBtoHSV(color[0],color[1],color[2]);
							if (hsv!==false) {
								d.dataset.editvalue=HSVtoHSVHEX(hsv[0],hsv[1],hsv[2]);
							}
							var rgb=RGBtoRGBHEX(color[0],color[1],color[2]);
							if (rgb!==false) {
								tmp.style.borderColor="#"+rgb;					
							}
						}
								
					}
				}
			}
		}
	}
}

function control15_Send() {
	var d=document.getElementById("e-"+elementDragId);
	if (d && d.dataset.controltyp==15) {

		if (d.dataset.editvalue!="") {
			setKoValue(d.dataset.gaid2,d.dataset.editvalue);
			if (d.dataset.var2!=1) {
				showShortClickItem(document.getElementById("e-"+elementDragId+"-send"));
			}
		}

		document.getElementById("e-"+elementDragId+"-text").style.display="inline";
		document.getElementById("e-"+elementDragId+"-edit").style.display="none";

		elementDragId=0;
		window.removeEventListener(moveEvent,control15_Move,false);
		window.removeEventListener(upEvent,control15_Send,false);

		if (visu_allowScrolling) {
			//Scrolling wieder freigeben
			window.removeEventListener(moveEvent,disableScrolling,false);
		}

	}
}
