/* 
 * EDOMI beta (Version 1.52) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 24 (Codeschloss)
//----------------------------

function control24_constructControl(obj,item) {
	if (obj.dataset.var3==0) { 
		//normal
		var n="<table id='e-"+item.id+"-bg1' cellpadding='0' cellspacing='0' border='0' style='left:0; top:0; width:100%; height:100%;'>";
			n+="<tr align='center'><td id='e-"+item.id+"-k1'>1</td><td id='e-"+item.id+"-k2'>2</td><td id='e-"+item.id+"-k3'>3</td></tr>";
			n+="<tr align='center'><td id='e-"+item.id+"-k4'>4</td><td id='e-"+item.id+"-k5'>5</td><td id='e-"+item.id+"-k6'>6</td></tr>";
			n+="<tr align='center'><td id='e-"+item.id+"-k7'>7</td><td id='e-"+item.id+"-k8'>8</td><td id='e-"+item.id+"-k9'>9</td></tr>";
			n+="<tr align='center'>";
				n+="<td id='e-"+item.id+"-ki'>";
					n+="<div id='e-"+item.id+"-info' style='color:"+visu_indiColor+";'></div>";
					n+="<input id='e-"+item.id+"-edit' type='password' value='' onBlur='control24_KeyboardCancel(\""+item.id+"\");' on"+downEvent+"='clickCancel();' onkeydown='if (event.keyCode==13){control24_KeyboardSend(\""+item.id+"\");}' class='input' style='display:none; left:0; top:0; background:transparent; color:"+visu_indiColorText+";'>";
				n+="</td>";
				n+="<td id='e-"+item.id+"-k0'>0</td><td id='e-"+item.id+"-kd'>-</td>";
			n+="</tr>";
		n+="</table>";
		
	} else { 
		//mit Tastenkreuz
		var n="<table id='e-"+item.id+"-bg1' cellpadding='0' cellspacing='0' border='0' style='left:0; top:0; width:100%; height:100%; border-collapse:collapse;'>";
			n+="<tr align='center'><td id='e-"+item.id+"-k1' style='border-bottom:1px solid;'>1</td><td id='e-"+item.id+"-k2' style='border-bottom:1px solid; border-left:1px solid; border-right:1px solid;'>2</td><td id='e-"+item.id+"-k3' style='border-bottom:1px solid;'>3</td></tr>";
			n+="<tr align='center'><td id='e-"+item.id+"-k4' style='border-bottom:1px solid;'>4</td><td id='e-"+item.id+"-k5' style='border-bottom:1px solid; border-left:1px solid; border-right:1px solid;'>5</td><td id='e-"+item.id+"-k6' style='border-bottom:1px solid;'>6</td></tr>";
			n+="<tr align='center'><td id='e-"+item.id+"-k7' style='border-bottom:1px solid;'>7</td><td id='e-"+item.id+"-k8' style='border-bottom:1px solid; border-left:1px solid; border-right:1px solid;'>8</td><td id='e-"+item.id+"-k9' style='border-bottom:1px solid;'>9</td></tr>";
			n+="<tr align='center'>";
				n+="<td id='e-"+item.id+"-ki'>";
					n+="<div id='e-"+item.id+"-info' style='color:"+visu_indiColor+";'></div>";
					n+="<input id='e-"+item.id+"-edit' type='password' value='' onBlur='control24_KeyboardCancel(\""+item.id+"\");' on"+downEvent+"='clickCancel();' onkeydown='if (event.keyCode==13){control24_KeyboardSend(\""+item.id+"\");}' class='input' style='display:none; left:0; top:0; background:transparent; color:"+visu_indiColorText+";'>";
				n+="</td>";
				n+="<td id='e-"+item.id+"-k0' style='border-left:1px solid; border-right:1px solid;'>0</td><td id='e-"+item.id+"-kd'>-</td>";
			n+="</tr>";
		n+="</table>";
	}
	obj.innerHTML=n;

	obj.dataset.code="";

	document.getElementById("e-"+item.id+"-k1").addEventListener(downEvent,function(){if (!checkClick()){return;} control24_KeyPress(item.id,1,this);},false);
	document.getElementById("e-"+item.id+"-k2").addEventListener(downEvent,function(){if (!checkClick()){return;} control24_KeyPress(item.id,2,this);},false);
	document.getElementById("e-"+item.id+"-k3").addEventListener(downEvent,function(){if (!checkClick()){return;} control24_KeyPress(item.id,3,this);},false);
	document.getElementById("e-"+item.id+"-k4").addEventListener(downEvent,function(){if (!checkClick()){return;} control24_KeyPress(item.id,4,this);},false);
	document.getElementById("e-"+item.id+"-k5").addEventListener(downEvent,function(){if (!checkClick()){return;} control24_KeyPress(item.id,5,this);},false);
	document.getElementById("e-"+item.id+"-k6").addEventListener(downEvent,function(){if (!checkClick()){return;} control24_KeyPress(item.id,6,this);},false);
	document.getElementById("e-"+item.id+"-k7").addEventListener(downEvent,function(){if (!checkClick()){return;} control24_KeyPress(item.id,7,this);},false);
	document.getElementById("e-"+item.id+"-k8").addEventListener(downEvent,function(){if (!checkClick()){return;} control24_KeyPress(item.id,8,this);},false);
	document.getElementById("e-"+item.id+"-k9").addEventListener(downEvent,function(){if (!checkClick()){return;} control24_KeyPress(item.id,9,this);},false);
	document.getElementById("e-"+item.id+"-k0").addEventListener(downEvent,function(){if (!checkClick()){return;} control24_KeyPress(item.id,0,this);},false);
	document.getElementById("e-"+item.id+"-kd").addEventListener(downEvent,function(){if (!checkClick()){return;} control24_KeyPress(item.id,-1,this);},false);
	document.getElementById("e-"+item.id+"-ki").addEventListener(downEvent,function(){if (!checkClick()){return;} control24_KeyboardStart(item.id,this);},false);
}

function control24_refreshControl(obj,design,init) {
}

function control24_KeyboardStart(elementId,obj) {
	var d=document.getElementById("e-"+elementId);
	var info=document.getElementById("e-"+elementId+"-info");
	var edit=document.getElementById("e-"+elementId+"-edit");
	if (d) {
		if (d.dataset.var2>0) {
			document.getElementById("e-"+elementId+"-ki").className="shortClick";
			if (d.dataset.resettimer) {clearTimeout(d.dataset.resettimer);}
			d.dataset.code="";
			info.innerHTML="";
			edit.value="";
			info.style.display="none";
			edit.style.display="inline-block";
			window.setTimeout(function(){if (document.getElementById("e-"+elementId+"-edit")) {document.getElementById("e-"+elementId+"-edit").focus();}},250); //Focus braucht Verzögerung, sonst klappts nicht
		} else {
			//Codeschloss ist blockiert
			shakeObj("e-"+elementId+"-bg1");
		}
	}
}

function control24_KeyboardSend(elementId) {
	var d=document.getElementById("e-"+elementId);
	var info=document.getElementById("e-"+elementId+"-info");
	var edit=document.getElementById("e-"+elementId+"-edit");
	if (d) {
		if (d.dataset.var2>0) {
			var n=elementId+AJAX_SEPARATOR1+edit.value+AJAX_SEPARATOR1;
			edit.value="";
			ajax("codeCheck",1024,visu_visuid,0,n,"");
		}
	}
}

function control24_KeyboardCancel(elementId) {
	var d=document.getElementById("e-"+elementId);
	var info=document.getElementById("e-"+elementId+"-info");
	var edit=document.getElementById("e-"+elementId+"-edit");
	if (d) {
		document.getElementById("e-"+elementId+"-ki").className="";
		info.style.display="inline-block";
		edit.style.display="none";
	}
}

function control24_KeyPress(elementId,key,obj) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		var bg1=document.getElementById("e-"+elementId+"-bg1");
		var info=document.getElementById("e-"+elementId+"-info");
		var edit=document.getElementById("e-"+elementId+"-edit");
		if (d.dataset.var2>0) {
			showShortClickItem(obj);
			if (edit.style.display!="none") {
				document.getElementById("e-"+elementId+"-ki").className="";
				info.style.display="inline-block";
				edit.style.display="none";
			}

			if (d.dataset.code.length<d.dataset.var1) {
				if (key>=0 && key<=9) {
					d.dataset.code+=(key+"");
					if (d.dataset.resettimer) {clearTimeout(d.dataset.resettimer);}
					d.dataset.resettimer=window.setTimeout("control24_Reset('"+elementId+"');",3000);
				}
				if (key==-1) {
					if (d.dataset.resettimer) {clearTimeout(d.dataset.resettimer);}
					d.dataset.code="";
				}

				bg1.style.background="transparent";
				var n="";
				for (var t=1;t<=d.dataset.code.length;t++) {n+="&middot;";}
				info.innerHTML=n;

			} 
			
			if (d.dataset.code.length==d.dataset.var1) {
				var n=elementId+AJAX_SEPARATOR1+d.dataset.code+AJAX_SEPARATOR1;
				d.dataset.code="";
				ajax("codeCheck",1024,visu_visuid,0,n,"");
			}

		} else {
			//Codeschloss ist blockiert
			shakeObj("e-"+elementId+"-bg1");
			info.innerHTML="";
		}
	}
}

function control24_Reset(elementId) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		var info=document.getElementById("e-"+elementId+"-info");
		d.dataset.code="";
		info.innerHTML="";
	}
}

//PHP-Callbacks
//----------------------------

function control24_callbackCodecheck(elementId,ok,tryCount) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		var info=document.getElementById("e-"+elementId+"-info");
		var edit=document.getElementById("e-"+elementId+"-edit");
		if (d.dataset.resettimer) {clearTimeout(d.dataset.resettimer);}
		d.dataset.code="";
		info.innerHTML="";
		if (ok) {
			d.dataset.var2=tryCount;
			if (d.dataset.gaid2>=1) {setKoValue(d.dataset.gaid2,1);}
			visuElementClick(elementId);	//Befehle ausführen
		} else {
			shakeObj("e-"+elementId+"-bg1");
			d.dataset.var2=parseInt(d.dataset.var2)-1;
			if (d.dataset.var2<=0) {
				if (d.dataset.gaid2>=1) {setKoValue(d.dataset.gaid2,-1);}
				document.getElementById("e-"+elementId+"-ki").className="";
				info.style.display="inline-block";
				edit.style.display="none";
			} else {
				if (d.dataset.gaid2>=1) {setKoValue(d.dataset.gaid2,0);}
			}
		}
	}
}
