/* 
 * EDOMI beta (Version 1.52) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 25 (Meldungsarchiv)
//----------------------------

function control25_constructControl(obj,item) {

	var mheight=(obj.dataset.var10!='')?obj.dataset.var10:40;

	var n="<table cellpadding='0' cellspacing='0' border='0' style='position:absolute; left:0; top:0; width:100%; height:100%;'>";
		n+="<tr style='height:"+mheight+"px;'>";
			n+="<td width='20%' align='center' id='e-"+item.id+"-last'>&larr;</td>";
			n+="<td width='60%' align='center' id='e-"+item.id+"-info'><div id='e-"+item.id+"-infotext' style='max-height:"+mheight+"px; overflow:hidden;'>"+item.title+"</div></td>";
			n+="<td width='20%' align='center' id='e-"+item.id+"-next'>&rarr;</td>";
		n+="</tr>";
		n+="<tr><td colspan='3' align='center' style='border-top:1px solid;'><div style='position:relative; height:100%;'><div id='e-"+item.id+"-edit' style='position:absolute; top:0; left:0; right:0; bottom:0; overflow-x:hidden; overflow-y:auto;'></div></div></td></tr>";
	n+="</table>";
	obj.innerHTML=n;
	
	obj.dataset.cursor="";
	obj.dataset.blocked=0;	

	if (obj.dataset.var0==1) {document.getElementById("e-"+item.id+"-edit").addEventListener(downEvent,function(){if (!checkClick()){return;} visuElementClick(item.id);},false);}

	if (obj.dataset.var3==0) { 
		//Listenansicht
		document.getElementById("e-"+item.id+"-last").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); scrollUp("e-"+item.id+"-edit");},false);
		document.getElementById("e-"+item.id+"-info").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); control25_ShowInfo(item.id,0);},false);
		document.getElementById("e-"+item.id+"-next").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); scrollDown("e-"+item.id+"-edit");},false);
	} else {
		//Einzelmeldung
		document.getElementById("e-"+item.id+"-last").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); control25_ShowInfo(item.id,-1);},false);
		document.getElementById("e-"+item.id+"-info").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); control25_ShowInfo(item.id,0);},false);
		document.getElementById("e-"+item.id+"-next").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); control25_ShowInfo(item.id,1);},false);
	}
}

function control25_refreshControl(obj,design,init) {
	if (init || obj.dataset.var5==1) {
		control25_ShowInfo(design.elementid,0);
	}
}

function control25_ShowInfo(elementId,mode) {
	//mode: 0=Neustart, 1=Nachladen
	//		bei Einzelmeldungs-Ansicht: -1=vorherigen Eintrag, 1=nachfolgenden Eintrag
	var d=document.getElementById("e-"+elementId);
	if (d) {
		if (d.dataset.blocked==0) {	
			d.dataset.blocked=1;

			if (mode==0) {d.dataset.cursor=0;}
			var n=elementId+AJAX_SEPARATOR1+mode+AJAX_SEPARATOR1+d.dataset.cursor+AJAX_SEPARATOR1+d.dataset.var1+AJAX_SEPARATOR1+d.dataset.var2+AJAX_SEPARATOR1+d.dataset.var3+AJAX_SEPARATOR1+d.dataset.var4+AJAX_SEPARATOR1;
			ajax("archivInfo",1025,visu_visuid,0,n,"");
		}
	}
}

function control25_LoadMore(elementId,rows) {
	if (!event) var event=window.event;
	event.stopPropagation();
	var d=document.getElementById("e-"+elementId);
	if (d) {
		d.dataset.cursor=parseInt(d.dataset.cursor)+rows;
		control25_ShowInfo(elementId,1);
	}
}

function control25_DeleteMessage(elementId,targetId,ts1,ts2) {
	if (!event) var event=window.event;
	event.stopPropagation();
	showShortClickItem(document.getElementById("e-"+elementId+"-edit"));
	var d=document.getElementById("e-"+elementId);
	if (d) {
		var n=elementId+AJAX_SEPARATOR1+targetId+AJAX_SEPARATOR1+ts1+AJAX_SEPARATOR1+ts2+AJAX_SEPARATOR1;
		ajax("archivDelete",1025,visu_visuid,0,n,"");
	}
}

//PHP-Callbacks
//----------------------------

function control25_callbackLoaded(elementId,content,cursor,scroll) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		d.dataset.blocked=0;

		d.dataset.cursor=cursor;
		document.getElementById("e-"+elementId+"-edit").innerHTML=content;
		if (scroll) {scrollToTop("e-"+elementId+"-edit");}
	}
}

